diff -wrubN quake3_1.32b/code/win32/win_input.c dfengine_1.07_src/code/win32/win_input.c
--- quake3_1.32b/code/win32/win_input.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/win32/win_input.c	2009-05-19 14:03:24.000000000 +0200
@@ -32,6 +32,7 @@
 	qboolean	mouseActive;
 	qboolean	mouseInitialized;
   qboolean  mouseStartupDelayed; // delay mouse init to try DI again when we have a window
+	qboolean	mouseRaw;	// Cgg - raw input
 } WinMouseVars_t;
 
 static WinMouseVars_t s_wmv;
@@ -187,6 +188,48 @@
 /*
 ============================================================
 
+RAW INPUT MOUSE
+(Cgg)
+
+============================================================
+*/
+qboolean IN_InitRawMouse() {
+	// http://www.usb.org/developers/devclass_docs/Hut1_12.pdf
+	RAWINPUTDEVICE dev = {
+		1,	// usUsagePage - generic desktop controls
+		2,	// usUsage - mouse
+		0,	// dwFlags
+		0	// hwndTarget
+	};
+	if (!RegisterRawInputDevices(&dev, 1, sizeof(dev))) {
+		Com_Printf("Raw input registration failed. (0x%x)\n", GetLastError());
+		return qfalse;
+	}
+	Com_Printf("Registered for raw input.\n");
+	s_wmv.mouseRaw = qtrue;
+	return qtrue;
+}
+
+void IN_ShutdownRawMouse() {
+	RAWINPUTDEVICE dev = {
+		1,	// usUsagePage - generic desktop controls
+		2,	// usUsage - mouse
+		RIDEV_REMOVE,	// dwFlags
+		0	// hwndTarget
+	};
+	s_wmv.mouseRaw = qfalse;
+	if (!RegisterRawInputDevices(&dev, 1, sizeof(dev))) {
+		Com_Printf("Mouse release failed. (0x%x)\n", GetLastError());
+	}
+}
+
+qboolean IN_RawMouseActive() {
+	return s_wmv.mouseActive && s_wmv.mouseRaw;
+}
+
+/*
+============================================================
+
 DIRECT INPUT MOUSE CONTROL
 
 ============================================================
@@ -571,10 +614,15 @@
 	}
 
 	if ( in_mouse->integer == -1 ) {
-		Com_Printf ("Skipping check for DirectInput\n");
+		Com_Printf ("Skipping check for DirectInput and Raw Input\n");
+	} else if (in_mouse->integer == 3) {	// Cgg - raw input
+		if (IN_InitRawMouse()) {
+			s_wmv.mouseInitialized = qtrue;
+			return;
+		}
+		Com_Printf ("Falling back to Win32 mouse support...\n");
 	} else {
-    if (!g_wv.hWnd)
-    {
+		if (!g_wv.hWnd) {
       Com_Printf ("No window for DirectInput mouse init, delaying\n");
       s_wmv.mouseStartupDelayed = qtrue;
       return;
@@ -629,6 +677,13 @@
 void IN_MouseMove ( void ) {
 	int		mx, my;
 
+	// Cgg - raw input is based on wndproc events - not frames.
+	if ( s_wmv.mouseRaw ) {
+		// keep the windows cursor centered
+		SetCursorPos(window_center_x, window_center_y);
+		return;
+	}
+	// !Cgg
 	if ( g_pMouse ) {
 		IN_DIMouse( &mx, &my );
 	} else {
@@ -673,6 +728,7 @@
 void IN_Shutdown( void ) {
 	IN_DeactivateMouse();
 	IN_ShutdownDIMouse();
+	IN_ShutdownRawMouse();
 	IN_ShutdownMIDI();
 	Cmd_RemoveCommand("midiinfo" );
 }
diff -wrubN quake3_1.32b/code/win32/win_local.h dfengine_1.07_src/code/win32/win_local.h
--- quake3_1.32b/code/win32/win_local.h	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/win32/win_local.h	2009-05-21 14:53:03.000000000 +0200
@@ -63,6 +63,8 @@
 void	IN_Activate (qboolean active);
 void	IN_Frame (void);
 
+qboolean IN_RawMouseActive(); // Cgg
+
 // window procedure
 LONG WINAPI MainWndProc (
     HWND    hWnd,
@@ -75,6 +77,10 @@
 void SNDDMA_Activate( void );
 int  SNDDMA_InitDS ();
 
+// drakkar
+void GLW_WindowFocus(qboolean focus);
+// !drakkar
+
 typedef struct
 {
 	
diff -wrubN quake3_1.32b/code/win32/win_main.c dfengine_1.07_src/code/win32/win_main.c
--- quake3_1.32b/code/win32/win_main.c	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/win32/win_main.c	2009-05-21 14:53:03.000000000 +0200
@@ -1227,10 +1227,22 @@
 
     // main game loop
 	while( 1 ) {
-		// if not running as a game client, sleep a bit
-		if ( g_wv.isMinimized || ( com_dedicated && com_dedicated->integer ) ) {
-			Sleep( 5 );
+// drakkar - free CPU if window not active
+/*
+-		// if not running as a game client, sleep a bit
+-		if ( g_wv.isMinimized || ( com_dedicated && com_dedicated->integer ) ) {
+-			Sleep( 5 );
+-		}
+*/
+		if( com_dedicated && com_dedicated->integer )
+		{
+			// Sleep( 5 );  // why? linux version dont sleep
 		}
+		else if( !g_wv.activeApp )
+		{
+			Sleep( 100 );  // 10 fps, free CPU
+		}
+// !drakkar
 
 		// set low precision every frame, because some system calls
 		// reset it arbitrarily
diff -wrubN quake3_1.32b/code/win32/win_syscon.c dfengine_1.07_src/code/win32/win_syscon.c
--- quake3_1.32b/code/win32/win_syscon.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/win32/win_syscon.c	2009-04-19 20:02:08.000000000 +0200
@@ -334,7 +334,7 @@
 
 	s_wcd.hWnd = CreateWindowEx( 0,
 							   DEDCLASS,
-							   "Quake 3 Console",
+							   Q3_WINDOW_TITLE,	// Cgg
 							   DEDSTYLE,
 							   ( swidth - 600 ) / 2, ( sheight - 450 ) / 2 , rect.right - rect.left + 1, rect.bottom - rect.top + 1,
 							   NULL,
diff -wrubN quake3_1.32b/code/win32/win_wndproc.c dfengine_1.07_src/code/win32/win_wndproc.c
--- quake3_1.32b/code/win32/win_wndproc.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/win32/win_wndproc.c	2009-05-25 11:51:16.000000000 +0200
@@ -130,7 +130,7 @@
 	K_F6, K_F7, K_F8, K_F9, K_F10,  K_PAUSE,    0  , K_HOME, 
 	K_UPARROW,K_PGUP,K_KP_MINUS,K_LEFTARROW,K_KP_5,K_RIGHTARROW, K_KP_PLUS,K_END, //4 
 	K_DOWNARROW,K_PGDN,K_INS,K_DEL,0,0,             0,              K_F11, 
-	K_F12,0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0,        // 5
+	K_F12,0  ,    0  ,    0  ,    0  ,    K_MENU  ,    0  ,    0,        // 5
 	0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0, 
 	0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0,        // 6 
 	0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0  ,    0, 
@@ -214,6 +214,80 @@
 }
 
 
+// drakkar
+// http://support.microsoft.com/kb/226359
+LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
+{
+	int vkCode, isDown;
+
+	if( nCode == HC_ACTION )
+	{
+		vkCode = ((KBDLLHOOKSTRUCT *)lParam)->vkCode;
+		isDown = ( wParam == WM_SYSKEYDOWN || wParam == WM_KEYDOWN );
+
+		switch( vkCode )
+		{
+			// Disable Windows key
+			case VK_LWIN:
+			case VK_RWIN:
+				Sys_QueEvent( g_wv.sysMsgTime, SE_KEY, K_WIN, isDown, 0, NULL );
+				return 1;
+			break;
+
+            // Disable XXX+TAB : ALT+TAB, SHIFT+TAB
+			case VK_TAB:
+				Sys_QueEvent( g_wv.sysMsgTime, SE_KEY, K_TAB, isDown, 0, NULL );
+				return 1;
+			break;
+
+			// Disable ALT+XXX : ALT+F4, ALT+TAB
+			case VK_LMENU:
+				Sys_QueEvent( g_wv.sysMsgTime, SE_KEY, K_ALT, isDown, 0, NULL );
+				return 1;
+			break;
+
+			// Disable XXX+ESC : CTRL+ESC, ALT+ESC, SHIFT+ESC
+			case VK_ESCAPE:
+				Sys_QueEvent( g_wv.sysMsgTime, SE_KEY, K_ESCAPE, isDown, 0, NULL );
+				return 1;
+			break;
+		}
+	}
+
+    return CallNextHookEx( 0, nCode, wParam, lParam );
+}
+// !drakkar
+
+
+// drakkar
+static HHOOK hHook = NULL;
+void EnableLowLevelKeyboard(qboolean enable)
+{
+	if( enable )
+	{
+		if( !hHook )
+		{
+			// WH_KEYBOARD_LL -> Windows NT/2000/XP
+			hHook = SetWindowsHookEx( WH_KEYBOARD_LL, LowLevelKeyboardProc, g_wv.hInstance, 0 );
+			if( !hHook )
+			{
+				Com_Printf("Could not create key hook ( LowLevelKeyboard )\n");
+			}
+		}
+	}
+	else
+	{
+		if( hHook )
+		{
+			UnhookWindowsHookEx( hHook );
+			hHook = NULL;
+		}
+	}
+}
+// !drakkar
+
+
+
 /*
 ====================
 MainWndProc
@@ -314,15 +388,20 @@
 		r_fullscreen = Cvar_Get ("r_fullscreen", "1", CVAR_ARCHIVE | CVAR_LATCH );
 
 		MSH_MOUSEWHEEL = RegisterWindowMessage("MSWHEEL_ROLLMSG"); 
-		if ( r_fullscreen->integer )
-		{
+		// drakkar - never use low level ALT+TAB
+/*
+-		if ( r_fullscreen->integer )
+-		{
+-			WIN_DisableAltTab();
+-		}
+-		else
+-		{
+-			WIN_EnableAltTab();
+-		}
+*/
+		EnableLowLevelKeyboard( qtrue );
 			WIN_DisableAltTab();
-		}
-		else
-		{
-			WIN_EnableAltTab();
-		}
-
+		// !drakkar
 		break;
 #if 0
 	case WM_DISPLAYCHANGE:
@@ -341,27 +420,58 @@
 	case WM_DESTROY:
 		// let sound and input know about this?
 		g_wv.hWnd = NULL;
-		if ( r_fullscreen->integer )
-		{
+		// drakkar
+/*
+-		if ( r_fullscreen->integer )
+-		{
+-			WIN_EnableAltTab();
+-		}
+*/
+		EnableLowLevelKeyboard( qfalse );
 			WIN_EnableAltTab();
-		}
+		// !drakkar
 		break;
 
 	case WM_CLOSE:
 		Cbuf_ExecuteText( EXEC_APPEND, "quit" );
 		break;
 
-	case WM_ACTIVATE:
-		{
-			int	fActive, fMinimized;
+	// drakkar - use WM_SETFOCUS and WM_KILLFOCUS messages
+/*
+-	case WM_ACTIVATE:
+-		{
+-			int	fActive, fMinimized;
+-
+-			fActive = LOWORD(wParam);
+-			fMinimized = (BOOL) HIWORD(wParam);
+-
+-			VID_AppActivate( fActive != WA_INACTIVE, fMinimized);
+-			SNDDMA_Activate();
+-		}
+-		break;
+*/
+	// !drakkar
 
-			fActive = LOWORD(wParam);
-			fMinimized = (BOOL) HIWORD(wParam);
+	// drakkar
+	case WM_SETFOCUS:
+		EnableLowLevelKeyboard( qtrue );
+		WIN_DisableAltTab();
+		GLW_WindowFocus( qtrue );
+	break;
+	case WM_KILLFOCUS:
+		EnableLowLevelKeyboard( qfalse );
+		WIN_EnableAltTab();
+		GLW_WindowFocus( qfalse );
+	break;
+	// !drakkar
 
-			VID_AppActivate( fActive != WA_INACTIVE, fMinimized);
-			SNDDMA_Activate();
-		}
+	// drakkar - dynamically set window size
+	case WM_SIZE:
+		if( wParam == SIZE_MINIMIZED ) Cmd_ExecuteString( "windowMode minimized\n" );
+		if( wParam == SIZE_MAXIMIZED ) Cmd_ExecuteString( "windowMode fullscreen\n" );
+		if( wParam == SIZE_RESTORED  ) Cmd_ExecuteString( "windowMode windowed\n" );		
 		break;
+	// !drakkar
 
 	case WM_MOVE:
 		{
@@ -406,6 +516,11 @@
 		{
 			int	temp;
 
+			// Cgg: ignore legacy messages when raw input is on
+			if (IN_RawMouseActive()) {
+				return 0;
+			}
+
 			temp = 0;
 
 			if (wParam & MK_LBUTTON)
@@ -421,21 +536,47 @@
 		}
 		break;
 
+	// Cgg - raw input
+	case WM_INPUT: {
+		RAWINPUT ri;
+		unsigned int i = sizeof(ri);
+		if (!IN_RawMouseActive()) {
+			return 0;
+		}
+		GetRawInputData((HRAWINPUT)lParam, RID_INPUT, &ri, &i, sizeof(RAWINPUTHEADER));
+		for (i=0; i<5; i++) {
+			if (ri.data.mouse.ulButtons & (1<<(i*2))) {
+				Sys_QueEvent(g_wv.sysMsgTime, SE_KEY, K_MOUSE1+i, qtrue, 0, NULL);
+			} else if (ri.data.mouse.ulButtons & (1<<(i*2+1))) {
+				Sys_QueEvent(g_wv.sysMsgTime, SE_KEY, K_MOUSE1+i, qfalse, 0, NULL);
+			}
+		}
+		if (ri.data.mouse.lLastX || ri.data.mouse.lLastY) {
+			Sys_QueEvent(0, SE_MOUSE, ri.data.mouse.lLastX, ri.data.mouse.lLastY, 0, NULL);
+		}
+		break;
+	}	
+	// !Cgg
+
 	case WM_SYSCOMMAND:
 		if ( wParam == SC_SCREENSAVE )
 			return 0;
 		break;
 
 	case WM_SYSKEYDOWN:
-		if ( wParam == 13 )
-		{
-			if ( r_fullscreen )
-			{
-				Cvar_SetValue( "r_fullscreen", !r_fullscreen->integer );
-				Cbuf_AddText( "vid_restart\n" );
-			}
-			return 0;
-		}
+// drakkar - dont swap fullscreen here, better in cl_keys.c
+/*
+-		if ( wParam == 13 )
+-		{
+-			if ( r_fullscreen )
+-			{
+-				Cvar_SetValue( "r_fullscreen", !r_fullscreen->integer );
+-				Cbuf_AddText( "vid_restart\n" );
+-			}
+-			return 0;
+-		}
+*/
+// !drakkar
 		// fall through
 	case WM_KEYDOWN:
 		Sys_QueEvent( g_wv.sysMsgTime, SE_KEY, MapKey( lParam ), qtrue, 0, NULL );
